Bug 475807 - [LTC 5.4 FEAT] Support IPv6 boot/install through yaboot [201166]
[LTC 5.4 FEAT] Support IPv6 boot/install through yaboot [201166]
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: yaboot (Show other bugs)
5.4
ppc64 All
high Severity high
: alpha
: 5.4
Assigned To: Roman Rakus
Alexander Todorov
: FutureFeature, OtherQA
Depends On:
Blocks: 445204 483784
  Show dependency treegraph
 
Reported: 2008-12-10 10:40 EST by IBM Bug Proxy
Modified: 2014-01-12 19:08 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 07:53:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Rearrange the code in preparation to fix ipv4 implementaion (13.65 KB, text/plain)
2009-01-26 22:30 EST, IBM Bug Proxy
no flags Details
Fix ipv4 implemantion to handle all the arguments properly. (9.75 KB, text/plain)
2009-01-26 22:40 EST, IBM Bug Proxy
no flags Details
Extract ipv4 functionality to a seperate function (2.03 KB, text/plain)
2009-01-26 22:40 EST, IBM Bug Proxy
no flags Details
Implement ipv6 functionality (4.95 KB, text/plain)
2009-01-26 22:40 EST, IBM Bug Proxy
no flags Details
Provide prom_get_netinfo (5.16 KB, text/plain)
2009-04-13 15:21 EDT, IBM Bug Proxy
no flags Details
Make sure older firmware works too. (5.67 KB, text/plain)
2009-04-13 15:21 EDT, IBM Bug Proxy
no flags Details
Changed patch (make_ipv4_changes_backward_comptible) (5.30 KB, patch)
2009-05-15 11:37 EDT, Roman Rakus
no flags Details | Diff
source rpm (326.51 KB, application/x-rpm)
2009-05-15 11:39 EDT, Roman Rakus
no flags Details
source rpm (325.52 KB, application/x-rpm)
2009-05-18 06:47 EDT, Roman Rakus
no flags Details
Target rpm (177.05 KB, application/x-rpm)
2009-05-18 06:48 EDT, Roman Rakus
no flags Details
backport of prom_claim_chunk patches. (4.62 KB, text/plain)
2009-05-20 03:35 EDT, IBM Bug Proxy
no flags Details
source rpm (327.12 KB, application/octet-stream)
2009-06-02 04:49 EDT, Roman Rakus
no flags Details
Final yaboot rpm (177.13 KB, application/octet-stream)
2009-06-02 04:50 EDT, Roman Rakus
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
IBM Linux Technology Center 50306 None None None Never

  None (edit)
Description IBM Bug Proxy 2008-12-10 10:40:47 EST
=Comment: #0=================================================
Emily J. Ratliff <ratliff@austin.ibm.com> - 
1. Feature Overview:
Feature Id:	[201166]
a. Name of Feature:	Support IPv6 boot/install through yaboot
b. Feature Description
Add the IPv6 capability to yaboot.

2. Feature Details:
Sponsor:	PPC
Architectures:
ppc64

Arch Specificity: Purely Arch Specific Code
Affects Installer: Yes
Delivery Mechanism: Device Driver
Category:	Device Drivers and IO
Request Type:	Other
d. Upstream Acceptance:	In Progress
Sponsor Priority	1
f. Severity: High
IBM Confidential:	no
Code Contribution:	IBM code
g. Component Version Target:	posted the code to yaboot developer mailing list on Sep 15th, 2008.
Initial comments from the maintainer was favourable, but the code hasn't been accepted yet.

3. Business Case
The IPv6 boot/install capability is required on all platforms by mid-2008 for government business.

Benefits
This is to enable the IPv6 full support with Linux on Power systems. This capability is required by
all system sold to government by mid-2008.

4. Primary contact at Red Hat: 
John Jarvis
jjarvis@redhat.com

5. Primary contacts at Partner:
Project Management Contact:
Stephanie Glass, sglass@us.ibm.com, 512-838-9284

Technical contact(s):
Daisy Chang, daisyc@us.ibm.com
Chandra Seetharaman, chandra.seetharaman@us.ibm.com

IBM Manager:
Wendel Voigt, wvoigt@us.ibm.com
Comment 1 John Jarvis 2008-12-23 15:38:50 EST
IBM is signed up to test and provide feedback.
Comment 2 IBM Bug Proxy 2009-01-26 22:30:34 EST
Following are the direct port (to RHEL 5.3 yaboot tree) of the four patches I submitted to the yaboot-dev mailing list on Sep 15, 2008 to support ipv6 net boot: http://www.nabble.com/-PATCH-0-4--yaboot-tftp-boot-extensions-and-ipv6-support-tt19503401.html#a19503401

I am still working with the maintainer to get these into his tree.

ipv6 implementation was done after consultation with the maintainer. He is in agreement with the implementation.

He has just been very busy
Comment 3 IBM Bug Proxy 2009-01-26 22:30:38 EST
Created attachment 330057 [details]
Rearrange the code in preparation to fix ipv4 implementaion



There is no functional change in this patch. This is just to prepare the
code for the following patch.

This patch just replaces the arguments "char *dev_name" and "char *file_name"
with "struct boot_fspec_t fspec".
Comment 4 IBM Bug Proxy 2009-01-26 22:40:44 EST
Created attachment 330058 [details]
Fix ipv4 implemantion to handle all the arguments properly.



Currently, yaboot works properly when there is a tftp boot server serving
the broadcast requests sent in the network.

If the user specifies siaddr, ciaddr, and other arguments in the command
line, it is not handled appropriately.

This patch changes that behavior and make yaboot work properly in both cases.

The semantics specified in section 4.1 of
http://playground.sun.com/1275/practice/obp-tftp/tftp1_0.pdf is followed.
([bootp,]siaddr,filename,ciaddr,giaddr,bootp-retries,tftp-retries)
Comment 5 IBM Bug Proxy 2009-01-26 22:40:48 EST
Created attachment 330059 [details]
Extract ipv4 functionality to a seperate function



This patch just extracts the ipv4 arguments extraction into a separate
function. No fucntional change.

This is just in preparation for the next patch which adds supports for
ipv6.
Comment 6 IBM Bug Proxy 2009-01-26 22:40:52 EST
Created attachment 330060 [details]
Implement ipv6 functionality



This patch adds support for handling ipv6 boot parameters for POWER
architecture.

This is implementation derived. 

This follows the semantics defined in section 4.3.1 of
http://www.power.org/apps/org/workgroup/parch/download.php/2380/latest
(It is under the Members area of TSC - Platform Architecture committee).
Comment 7 IBM Bug Proxy 2009-02-13 01:40:54 EST
Yes, you can.

In the home page (http://www.power.org), look for "Join Power.org", Click on that link and proceed to become a member.
Comment 8 John Jarvis 2009-03-24 16:48:43 EDT
Did this ever get accepted upstream?
Comment 9 IBM Bug Proxy 2009-03-26 16:00:38 EDT
------- Comment From sekharan@us.ibm.com 2009-03-26 15:57 EDT-------
Hi John,

It has _not_ been accepted by the maintainer yet.

He has been way too busy and is currently in the process of transitioning the maintainership to a different person :(.

------- Comment From sekharan@us.ibm.com 2009-03-26 15:57 EDT-------
BTW, I am working with the future maintainer in getting this accepted.
Comment 10 IBM Bug Proxy 2009-04-13 15:21:15 EDT
------- Comment From sekharan@us.ibm.com 2009-04-13 15:11 EDT-------
During Testing Tony Breeds found a backward compatibility issues, which needed a patch to be added.

This patch needed a function (prom_get_netinfo()), which was not in RHEL 5.3, but is already in mainline yaboot.

So, adding those two patches
Comment 11 IBM Bug Proxy 2009-04-13 15:21:21 EDT
Created attachment 339359 [details]
Provide prom_get_netinfo


------- Comment on attachment From sekharan@us.ibm.com 2009-04-13 15:17 EDT-------


Already in maintainer's tree: http://github.com/pnasrat/yaboot/commit/78cfabe0fac2682681c604bfe9b7266f173b9ea2
Comment 12 IBM Bug Proxy 2009-04-13 15:21:26 EDT
Created attachment 339360 [details]
Make sure older firmware works too.


------- Comment (attachment only) From sekharan@us.ibm.com 2009-04-13 15:17 EDT-------
Comment 13 Roman Rakus 2009-05-04 09:18:08 EDT
Will these patches be yaboot head?
Comment 14 IBM Bug Proxy 2009-05-05 13:54:39 EDT
------- Comment From sekharan@us.ibm.com 2009-05-05 13:44 EDT-------
(In reply to comment #27)
> Will these patches be yaboot head?
>

Yes.

That is my understanding after long email discussions with the current and future maintainers.
Comment 15 Roman Rakus 2009-05-06 04:16:26 EDT
Thanks. I can make new yaboot for RHEL 5 after it is in upstream and in fedora rawhide.
Comment 16 IBM Bug Proxy 2009-05-06 12:51:21 EDT
------- Comment From sekharan@us.ibm.com 2009-05-06 12:40 EDT-------
Confused.... I thought you were considering it for RHEL 5.4 if it has hopes of getting into upstream...

Anyways....

You mean to say that these patches will _not_ be in 5.4 ?
Or
It can make 5.4 if they get into yaboot head by a specific date ?
Comment 17 Roman Rakus 2009-05-07 05:47:48 EDT
Pathes should be also in fedora rawhide to prevent regressions. When the pathes will be in yaboot head, then it's sure to be in next release of yaboot -> in rawhide. So there will be no regressions.
The deadline is 2009-05-15 IIRC.
Comment 18 Roman Rakus 2009-05-07 09:27:50 EDT
The deadline is 2009-05-14.
Comment 19 IBM Bug Proxy 2009-05-11 21:11:36 EDT
------- Comment From tonyb@au1.ibm.com 2009-05-11 21:07 EDT-------
(In reply to comment #31)
> Pathes should be also in fedora rawhide to prevent regressions. When the pathes
> will be in yaboot head, then it's sure to be in next release of yaboot -> in
> rawhide. So there will be no regressions.
> The deadline is 2009-05-15 IIRC.
>

Most of the patches on this bug are in F-11, you can monitor the evolution of the ipv4 netboot for F-11
on  RHbug #458438.  The only patch missing from F-11 is "Implement ipv6 functionality", which can be
added to devel.  I can then fold in the bug fixes from F-11 into devel once they're resolved and F-11
is out the door.  Is that acceptable?

In terms of upstream acceptance, that's beyond our influence currently.
Comment 20 Roman Rakus 2009-05-13 05:04:05 EDT
ok
Trust the patch will be accepted by upstream soon.
Comment 22 John Jarvis 2009-05-13 10:35:05 EDT
This enhancement request was evaluated by the full Red Hat Enterprise Linux 
team for inclusion in a Red Hat Enterprise Linux minor release.   As a 
result of this evaluation, Red Hat has tentatively approved inclusion of 
this feature in the next Red Hat Enterprise Linux Update minor release.   
While it is a goal to include this enhancement in the next minor release 
of Red Hat Enterprise Linux, the enhancement is not yet committed for 
inclusion in the next minor release pending the next phase of actual 
code integration and successful Red Hat and partner testing.
Comment 23 Roman Rakus 2009-05-15 11:26:21 EDT
" Make sure older firmware works too." patch doesn't fit well. I have made small change. I will prepare rpm. Will you be able to test it?
Comment 24 IBM Bug Proxy 2009-05-15 11:34:32 EDT
(In reply to comment #14)
> Created an attachment (id=42725) [details]
> Implement ipv6 functionality
> This patch adds support for handling ipv6 boot parameters for POWER
> architecture.
> This is implementation derived.
>
> This follows the semantics defined in section 4.3.1 of
> http://www.power.org/apps/org/workgroup/parch/download.php/2380/latest
> (It is under the Members area of TSC - Platform Architecture committee).
>

Is there some way I can get access to this "Members area" to read the detials?









>






>
Comment 25 Roman Rakus 2009-05-15 11:37:06 EDT
Created attachment 344185 [details]
Changed patch (make_ipv4_changes_backward_comptible)

Here is changed patch.
Comment 26 Roman Rakus 2009-05-15 11:39:57 EDT
Created attachment 344186 [details]
source rpm

Can you please try this srpm?
Comment 27 IBM Bug Proxy 2009-05-15 12:03:47 EDT
------- Comment From tpnoonan@us.ibm.com 2009-05-15 11:58 EDT-------
Red Hat needs some test feedback on this feature to make it happen for 5.4, please provide this test feedback.
Comment 28 IBM Bug Proxy 2009-05-15 14:41:39 EDT
------- Comment From sekharan@us.ibm.com 2009-05-15 14:33 EDT-------
Downloaded the source rpm. Will test it and report back soon (latest by EOD).
Comment 29 IBM Bug Proxy 2009-05-15 15:21:34 EDT
------- Comment From sekharan@us.ibm.com 2009-05-15 15:18 EDT-------
Having issues with the rpm:
-----------
[root@lab123 /]# rpm -ivh /tmp/yaboot-1.3.13-8.el5.src.rpm
1:yaboot                 warning: user rrakus does not exist - using root
warning: group rrakus does not exist - using root
########################################### [100%]
error: unpacking of archive failed on file /usr/src/redhat/SOURCES/ipv6_yaboot_1.patch;4a0dbf28: cpio: MD5 sum mismatch
---------

Can you please check and provide me a new one, please.
Comment 30 IBM Bug Proxy 2009-05-15 18:01:26 EDT
------- Comment From sekharan@us.ibm.com 2009-05-15 17:58 EDT-------
Just a note:

I compared both the patches mine and the one modified by Roman. Fun the code change point of view they are exactly same.
Comment 31 Roman Rakus 2009-05-18 06:47:00 EDT
Created attachment 344412 [details]
source rpm

Sorry for "bad" srpm.
This source rpm should be working.
Comment 32 Roman Rakus 2009-05-18 06:48:23 EDT
Created attachment 344414 [details]
Target rpm

And this is target rpm.
Please try this rpm.
Comment 33 Roman Rakus 2009-05-18 06:50:55 EDT
>I compared both the patches mine and the one modified by Roman. Fun the code
>change point of view they are exactly same.  
I have modified one patch. Here has name "Changed patch (make_ipv4_changes_backward_comptible)". I don't see them same. Other patches stay the same.
Comment 34 Roman Rakus 2009-05-19 08:37:11 EDT
Are you able to test it till Wednesday 20.? This is the last day. Thanks
Comment 35 IBM Bug Proxy 2009-05-20 03:35:20 EDT
Created attachment 344753 [details]
backport of prom_claim_chunk patches.


------- Comment on attachment From tonyb@au1.ibm.com 2009-05-20 03:24 EDT-------


This patch is the aggregate of backporting the following 2 patches from Scott Moser. 
  http://git.ozlabs.org/?p=yaboot.git;a=commit;h=f3d8af0e0ac4642499d5430c202ac57d1d4c5ceb
  http://git.ozlabs.org/?p=yaboot.git;a=commit;h=4ba173298fa8630628c9014028fccc22e511d48a
(These patches are in 1.3.14)

They are required to allow booting of kernels greater than 6Mb, the current RHEL5-3 install images is ~9Mb. While that is secondary to the IPv6 support it certainly makes sense. With this patch yaboot can netboot kernels upto 16Mb.

This patch on top of the 1.3.13-8 RPM doesn't break boot from disk and netbooting works as expected.
Comment 36 Roman Rakus 2009-05-20 08:20:29 EDT
yaboot-1.3.13-8.el5.ppc.rpm built.
backport of prom_claim_chunk patches included.
Comment 38 IBM Bug Proxy 2009-06-01 14:42:08 EDT
------- Comment From sekharan@us.ibm.com 2009-06-01 14:38 EDT-------
Hi rrakus,

Can you provide me a link to the rpm, please.

Thanks
Comment 39 Roman Rakus 2009-06-02 04:49:52 EDT
Created attachment 346210 [details]
source rpm

This is source rpm
Comment 40 Roman Rakus 2009-06-02 04:50:58 EDT
Created attachment 346212 [details]
Final yaboot rpm

And this is final yaboot rpm.
Comment 41 Chris Ward 2009-06-14 19:19:05 EDT
~~ Attention Partners RHEL 5.4 Partner Alpha Released! ~~

RHEL 5.4 Partner Alpha has been released on partners.redhat.com. There should
be a fix present that addresses this particular request. Please test and report back your results here, at your earliest convenience. Our Public Beta release is just around the corner!

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe the issues you encountered. If you have verified the request functions as expected, please set your Partner ID in the Partner field above to indicate successful test results. Do not flip the bug status to VERIFIED. Further questions can be directed to your Red Hat Partner Manager. Thanks!
Comment 42 IBM Bug Proxy 2009-06-22 01:32:34 EDT
(In reply to comment #14)
> Created an attachment (id=42725) [details]
> Implement ipv6 functionality
> This patch adds support for handling ipv6 boot parameters for POWER
> architecture.
> This is implementation derived.
>
> This follows the semantics defined in section 4.3.1 of
> http://www.power.org/apps/org/workgroup/parch/download.php/2380/latest
> (It is under the Members area of TSC - Platform Architecture committee).
>

Is there some way I can get access to this "Members area" to read the detials?

>

>

------- Comment From sekharan@us.ibm.com 2009-06-22 01:29 EDT-------
You can become a developer member thru the page http://www.power.org/join/devjoin/
Comment 43 Alexander Todorov 2009-07-03 06:46:26 EDT
IBM,
can you test if this issue is resolved in RHEL 5.4 Beta, which is available on RHN?

Thanks,
Alexander.
Comment 44 Chris Ward 2009-07-03 14:17:33 EDT
~~ Attention - RHEL 5.4 Beta Released! ~~

RHEL 5.4 Beta has been released! There should be a fix present in the Beta release that addresses this particular request. Please test and report back results here, at your earliest convenience. RHEL 5.4 General Availability release is just around the corner!

If you encounter any issues while testing Beta, please describe the issues you have encountered and set the bug into NEED_INFO. If you encounter new issues, please clone this bug to open a new issue and request it be reviewed for inclusion in RHEL 5.4 or a later update, if it is not of urgent severity.

Please do not flip the bug status to VERIFIED. Only post your verification results, and if available, update Verified field with the appropriate value.

Questions can be posted to this bug or your customer or partner representative.
Comment 45 IBM Bug Proxy 2009-07-08 19:12:19 EDT
------- Comment From sekharan@us.ibm.com 2009-07-08 19:09 EDT-------
Verified the ipv6 functionality to be working in 5.4 alpha  with yaboot version string:
Welcome to yaboot version 1.3.13 (Red Hat 1.3.13-8.el5)
Comment 46 Alexander Todorov 2009-07-09 02:54:33 EDT
Moving to VERIFIED as per comment #45
Comment 48 errata-xmlrpc 2009-09-02 07:53:19 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-1386.html

Note You need to log in before you can comment on or make changes to this bug.